#include <stdio.h> 
#include <stdlib.h>

/* bentigte Struktur zum Erzeugen der Stack-Eintrge */ 
typedef struct item_ {
   struct item_ *next;          /* Zeiger auf nchstoberstes Element */
   int value;                   /* wird erst fr Teil b gebraucht */
} item;

item *head = NULL;              /* Zeiger auf oberstes Element */

/* Freigabe eines Elements */ 
void trash(item * garbage) {   free(garbage);  }

/* ein neues Element anlegen */ 
item* new_item(int value) {
   item *new = (item *) malloc(sizeof(item));
   if (new) {
      new->value = value;
      new->next = NULL;
   }
   else printf("ERROR: allocation failed!\n");
   return new;
}

/* is_empty testet , ob an 'head' ein Element anhngig ist
   und liefert entsprechend 1 fr leer, 0 fr nicht leer */
int is_empty() { return head == NULL; }

/* das neue Element wird auf das derzeit oberste Element verzweigt,
   dann wird durch Umbiegen von 'head' das neue Element zum obersten */
void push(item * elem) {
   elem->next = head;
   head = elem;
}

/* erst wird das oberste Element mit einem Hilfszeiger zwischengespeichert,
   dann wird der head-Zeiger umgebogen, um das 2. zum 1. Element zu machen.
   Existiert kein Element im Stack, wird NULL zurueckgeliefert */
item *pop() {
   item *elem = NULL;

   if (!is_empty()) {
      elem = head;
      head = head->next;
   }
   return elem;
}
/* Teil b : mit drei Hilfsvariablen werden zuerst zwei Operanden mit 'pop'
   vom Stack geholt, dann werden die geholten Elemente auf Gueltigkeit geprft  (NULL) */
int multiplication() {
   item *erg = (item *) malloc(sizeof(item));
   item *op1;
   item *op2;

   op1 = pop();
   op2 = pop();
   if (op1 == NULL || op2 == NULL) {
      printf("stack underflow\n");
      return (0);
   }

   /* die Werte sind gltig, daher wird in der dritten Hilfsvariable
      das Ergebnis abgelegt. Dieses wird auf den Stack zurueckgeschrieben,
      der Speicher der alten Operanden wird wieder freigegeben */
   erg->value = op1->value * op2->value;
   push(erg);
   trash(op1);
   trash(op2);
   return 1;
}

/* Teil b : Multiplikation fuer n>0 Faktoren */
int multiplicationN() {
   item *cnt = pop();  /* get number of factors */
   item *erg = pop();
   item *op;

   if(cnt == NULL || erg == NULL) {
      printf("stack underflow\n");
      return (1);
   }

   while(cnt->value > 1) {
     op=pop();
     erg->value*=op->value;
     trash(op);	     
     --cnt->value;
   }
   trash(cnt);
   push(erg);
   return 0;
}

int main() {
   /* eigentlich ist in der Funktion main alles Teil b */
   int v,n,i;
   item *akku;

   printf("X : ");
   scanf("%i", &v);
   akku = new_item(v);          /* neues Element erzeugen */
   push(akku);                  /* und ablegen */
   printf("Y : ");
   scanf("%i", &v);
   akku = new_item(v);
   push(akku);                  /*  hier wurde das zweite erzeugt und abgelegt */
   multiplication();
   akku = pop();                /*  Produkt vom Stack holen */
   printf("X * Y = %i\n", akku->value); /* und ausgeben */
   trash(akku);                 /* Speicherplatz freigeben */


   printf("n : ");
   scanf("%i", &n);
   for(i=0;i!=n;++i) {
       printf("factor %i: ",i);
       scanf("%i", &v);
       push(new_item(v));
   }
   push(new_item(n));
   multiplicationN();
   akku = pop();   
   printf("product = %i\n", akku->value); 
   trash(akku);                 

   return 0;
}
